Subject: bug#78187: tsx-ts-mode: wrong indentation of object parameters

From: Yuan Fu <[email-masked]>
Date: Tue, 13 May 2025 12:56:31 -0700

> On May 10, 2025, at 3:17 AM, Eli Zaretskii <[email-masked]> wrote:
> 
>> From: Konstantin Kharlamov <[email-masked]>
>> Date: Thu, 01 May 2025 19:56:12 +0700
>> 
>> Given this snippet indented as expected:
>> 
>>    interface iface { f1: string,
>>                      f2: string
>>    }
>> 
>> indenting `f2` gives:
>> 
>>    interface iface { f1: string,
>>      f2: string
>>    }
>> 
>> May not be the best example, but JavaScript/TypeScript are heavy users of curly braces, and sometimes I do want to write the first field on the line with opening curly brace, which usually implies aligning other fields to it.
>> 
>> ---------
>> 
>> I spent quite some time trying to write a patch for this, but I am at loss. The closest I come to a solution is a rule:
>> 
>>    ((node-is "property_signature") prev-sibling 0)
>> 
>> it works correctly for every param starting with 2nd, but it misindents the 1st parameter. Probably some condition required like "for the 1st parameter do the offset, for consequent ones follow previous siblings indentation". But I have no idea how to do that.

The “match” matcher allow you to do that. You probably want to modify this rule:

 ((parent-is "interface_body") parent-bol typescript-ts-mode-indent-offset)

So each property aligns to the first non-comment sibling. And the first sibling aligns to the parent + 1 indent level.

I don’t think we have an existing anchor to find the first non-comment sibling, we might need to add something like (first-sibling-excluding “regexp”)

>> 
>> I looked at `c++-ts-mode` (which does it right) for inspiration, but couldn't figure out what it does in the same situation.

You can set treesit--indent-verbose to t and indent the line, then the matched rule will be printed in the echo area. Right now on master build, that indentation is handled by the c-ts-common-baseline-indent-rule, which is a smart baseline rule I created recently that can handle 90% of the indentation for C-like languages. We should probably migrate other C-like languages to use this rule, but that’s the topic for another discussion.

Yuan